"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""

#!/usr/bin/python

from thread import *
import os, pygame,sys,pickle,time,thread
from random import random
from pygame.locals import *

import sys,pickle,os,string,time,filecmp,copy
from string import *
from wxPython.wx import *
from wxPython.html import *
from wxPython.grid import *
from wxPython.lib.imagebrowser import *
import wx.lib.editor as editor

from dict_formatter import *
from config_editor import *

"""
This class accesses/edits the config in self.name directory.
NEED:use ConfigEditor
"""

DEBUG=True

class AdminTemplate:

	def __init__(self,dialog,parent,tab_name):#parent=educore
		self.dialog=dialog
		self.parent=parent
		self.tab_name=tab_name
		self.p=None
		self.ed=None
		
	def get_installed(self):
		
		fnames=os.listdir(self.parent.env.userdir)
		
		rnames=[]
		for f in fnames:
			if string.find(f,'.')<0:
				rnames.append(f)
		return rnames
	
	def edit_target(self,e):
		ip=self.ed.GetInsertionPoint()
		self.ed.Clear()
		target=self.combo_box.GetValue()
		sitepkgdir=self.parent.env.sitepkgdir
		configdir=self.parent.env.configdir
		userdir=self.parent.env.userdir
		
		if target=='':return
		
		cfg=None
		if userdir and target !='new':
			cfg=format_dict(self.parent.load_config(target),0)
			
		else:
			#cfg=format_dict(self.parent.global_config,0)
			cfg={
				'IDNgrade':		0,
				'IDNstudent':	0,
				'IDNsession':	0,
				'IDNteacher':	0,
				'username':'new',
				'password':'',
				'high_score':0,
			}
			cfg=format_dict(cfg,0)
		
		self.ed.WriteText(cfg)
		self.ed.SetInsertionPoint(ip)
	
	def reload(self,name):
		self.combo_box.Clear()
		installed=self.get_installed()
		for idx in range(len(installed)):
			self.combo_box.Append(installed[idx])
		self.combo_box.SetValue(name)
		self.edit_target(None)
				
	def setup(self,p):
		self.p=p
		
		installed=self.get_installed()

		#psize=p.GetSize()
		psize=(800,600)
		p.SetSize(psize)
		xc=psize[0]/2
		yc=psize[1]/2
		
		wcombo=170
		hcombo=30
		xcombo=xc-wcombo
		ycombo=10
		self.wcombo=wcombo
		self.hcombo=hcombo
		self.xcombo=xcombo
		self.ycombo=ycombo
		
		wsave=wcombo
		hsave=30
		xsave=xcombo
		ysave=ycombo+40
		
		wdelete=wcombo
		hdelete=30
		xdelete=xcombo
		ydelete=ycombo+40

		wlogout=wcombo
		hlogout=30
		xlogout=xcombo+wcombo
		ylogout=ycombo+40
		
		xeditor=0
		yeditor=30
		weditor=800
		heditor=800
		
		#layout the admin panel:
		hbox = wxBoxSizer(wxHORIZONTAL)
		box = wxBoxSizer(wxVERTICAL)
		
		#combo user select
		self.comboID=wxNewId()
		installed=self.get_installed()
		self.combo_box=wxComboBox(p,self.comboID,"",pos=wxPoint(xcombo,ycombo),size=wxSize(wcombo,hcombo),choices=installed)
		EVT_TEXT(p,self.comboID,self.edit_target)
		
		
		#save button
		xid=wxNewId()
		b1=wxButton(p,xid,"Save",pos=wxPoint(xsave,ysave),size=wxSize(wsave,hsave))
		EVT_BUTTON(self.p, xid, self.saveCB)

		#delete button
		xid=wxNewId()
		b2=wxButton(p,xid,"Delete",pos=wxPoint(xdelete,ydelete),size=wxSize(wdelete,hdelete))
		EVT_BUTTON(self.p, xid, self.deleteCB)
		
		#logout button
		xid=wxNewId()
		b3=wxButton(p,xid,"Logout",pos=wxPoint(xlogout,ylogout),size=wxSize(wlogout,hlogout))
		EVT_BUTTON(self.p, xid, self.logoutCB)

		#user editor
		
		#fontsize=eval(self.preferences['FontSize'])
		#fontname=eval(self.preferences['FontName'])
		font=wxFont(10,wxMODERN,wxNORMAL,wxNORMAL)
		self.ed=wxTextCtrl(p,wxNewId(),style=wxTE_MULTILINE|wxTE_RICH2|wxSUNKEN_BORDER)
		self.ed.SetFont(font)
		
		hbox.Add(self.combo_box, 0, 0, 1)
		hbox.Add(b1, 0, 0, 1)
		hbox.Add(b2, 0, 0, 1)
		hbox.Add(b3, 0, 0, 1)
		
		box.Add(hbox,0,wxALIGN_CENTER,1)
		box.Add(self.ed, 1, wxEXPAND, 1)
		
		p.SetSizer(box)
		
		self.p=p
		

	def deleteCB(self,e):
	
		d=eval(self.ed.GetValue(), {"__builtins__": {}})
		if d['username']=='new':return
		if d['username']=='admin':return
		if d['username']=='guest':return
		
		fname=os.path.join(self.parent.env.userdir,d['username'])
		try:os.removedirs(fname)
		except:pass#print 'unable to recursively delete 1x',fname
		
		cmd=None
		if self.parent.env.OS=='lin':cmd="rm -rf %s"%(fname)
		else:cmd="del %s"%(fname)
		print cmd
		try:os.system(cmd)
		except:pass#print 'unable to recursively delete 2x',fname
		
		self.reload("")
	
	def saveCB(self,e):
		"""
		if not self.configdir:
			self.cfg=eval(self.ed.GetValue())
			self.parent.cfg=eval(self.ed.GetValue())
			return
		"""
		d=None
		try:
			d=eval(self.ed.GetValue())
			
			if d['username']=='new':return
			else:oufdir=os.path.join(self.parent.env.userdir,d['username'])
			
			if not os.path.exists(oufdir):os.mkdir(oufdir)
			oufname=os.path.join(oufdir,'config')
			ouf=open(oufname,'w')
			ouf.write(string.replace(self.ed.GetValue(),'\\','\\\\'))
			ouf.close()
			
			self.reload(d['username'])
			
		except Exception,e:
			if DEBUG:print e
			self.reload('new')
			
		
	def logoutCB(self,e):
		self.dialog.EndModal(0)
		
