"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""
import os,sys,string,time,types
from wxPython.wx import *
import wx.lib.editor as editor

from environment import *
from dict_formatter import *

DEBUG=False

class ConfigEditor(wxPanel):
	def __init__(self,parent,mode,target,font,w,h):
		
		self.size=wxSize(w,h)
		self.parent=parent
		self.target=target
		self.x=None
		self.ID=wxNewId()
		
		if mode==0:wxPanel.__init__(self,parent,self.ID,wxDefaultPosition,name="EditorContainer")
		else:
			dialogsize=wxSize(w,h+100)
			self.x=wxDialog(parent,wxNewId(),'ConfigEditor',size=dialogsize)#optional to use this
			wxPanel.__init__(self,self.x,self.ID,wxDefaultPosition,name="EditorContainer")
		
		self.editor=wxTextCtrl(self,wxNewId(),style=wxTE_MULTILINE|wxTE_PROCESS_ENTER|wxTE_PROCESS_TAB)
		self.editor.SetFont(font)
		
		if target:
			inf=open(target)
			content=eval(inf.read(), {"__builtins__": {}})
			cfg=format_dict(content,0)
			self.editor.WriteText(cfg)
	
	def ShowModal(self):
		id_saveB=wxNewId()
		saveB=wxButton(self,id_saveB,"Save")
		EVT_BUTTON(saveB,id_saveB, self.saveCB)
		
		id_cancelB=wxNewId()
		cancelB=wxButton(self,id_cancelB,"Cancel")
		EVT_BUTTON(cancelB,id_cancelB, self.cancelCB)
		
		vbox=wxBoxSizer(wxVERTICAL)
		vbox.Add(self.editor,1,wxEXPAND,1)
		
		hbox=wxBoxSizer(wxHORIZONTAL)
		hbox.Add(saveB,0,1,1)
		hbox.Add(cancelB,0,1,1)
		vbox.Add(hbox,0,1,1)
		
		self.SetSizer(vbox)
		self.SetAutoLayout(True)

		self.x.Centre()
		rval=self.x.ShowModal()
		if rval==1:#SAVE
			self.save()

		return rval
	
	def saveCB(self,e):
		if DEBUG:print 'saveCB'
		self.x.EndModal(1)
		
	def cancelCB(self,e):
		if DEBUG:print 'cancelCB'
		self.x.EndModal(2)

	def save(self):
		ouf=open(self.target,'w')
		ouf.write(self.editor.GetValue())
		ouf.close()
		
