"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""
import sys,os,string,time
from random import random
from string import *

import pygame
from pygame.locals import *

if not pygame.font: print 'Warning, fonts disabled'
if not pygame.mixer: print 'Warning, sound disabled'

DEBUG=False

class EduAppWindow:
	
	def __init__(self,parent,username,MODE):#parent=educore
		
		self.parent=parent			
		self.env=parent.env
		self.configdir=parent.env.configdir
		self.userdir=parent.env.userdir
		self.sitepkgdir=parent.env.sitepkgdir
		self.username=username
		self.global_config=parent.global_config
		self.MODE=MODE
		
		self.user_config=None
		self.user_config=parent.load_config(os.path.join('accounts',username),'config')
		
		self.W=self.global_config['WIN_W']
		self.H=self.global_config['WIN_H']
		self.amfullscreen=-1
		self.movie_idx=0
		
	def save(self):
		
		if self.user_config['username']=='new':return self.global_config['high_score']
		
		oufname=os.path.join(self.userdir,self.username,'config')
			
		ouf=open(oufname,'w')
		ouf.write(`self.user_config`)
		ouf.close()
		
		if DEBUG:print "saved %s %d"%(self.user_config['username'],self.user_config['high_score'])
		
		return self.user_config['high_score']
		
	def load_config(self):
		
		configdir=self.configdir
		sitepkgdir=self.sitepkgdir
		userdir=self.userdir
		env=self.env
		
		infname=os.path.join(self.userdir,self.username,'config')
		f=open(infname)
		cfg=eval(f.read())
		f.close()
		
		return cfg
		
	def flip(self):
		pygame.display.flip()
		
	def run(self):#
		
		print 'eduapp.eduapp.py THIS DEFAULT BEHAVIOR SHOULD BE OVERRIDDEN'
		
		pygame.init()
		
		self.screen=pygame.display.set_mode((self.W,self.H))
		bkg = pygame.Surface(self.screen.get_size())
		self.bkg=bkg.convert()
		self.bkg.fill(self.user_config['default_fill_color'])
		pygame.display.set_caption(self.user_config['title_string'])
		
		while 1:
			self.screen.blit(self.bkg,(0,0))
			self.flip()
	
	def gocarousel(self):
		carousel=Carousel(self)
		rval=carousel.start()
		return rval

	def take_screenshot(self):
		display_surface=pygame.display.get_surface()
		tstamp=self.mktstamp()
		oufname="%s_%s.bmp"%(self.env.appname,tstamp)
		if self.env.OS=='lin':
			oufname=os.path.join(os.environ['HOME'],oufname)
		pygame.image.save(display_surface,oufname)
		

	def mktstamp(self):
		#tstamp which increases monotonically with time
		t=time.localtime()
		YYYY="%d"%t[0]
		MM="%02d"%t[1]
		DD="%02d"%t[2]
		hh="%02d"%t[3]
		mm="%02d"%t[4]
		ss="%02d"%t[5]
		tstamp="%s%s%s%s%s%s"%(YYYY,MM,DD,hh,mm,ss)
		return tstamp
