"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""
import os,sys,string,time,types
from wxPython.wx import *
import wx.lib.editor as editor

from environment import *
from dict_formatter import *

DEBUG=True
DEBUG=False

class EduAppEditor(wxPanel):
	def __init__(self,dialog,parent,mode,target,font,w,h,tab_name,env):
		self.dialog=dialog
		self.size=wxSize(w,h)
		self.parent=parent
		self.mode=mode
		self.target=target
		self.x=None
		self.ID=wxNewId()
		self.cb=None
		self.env=env
		self.tab_name=tab_name
		self.font=font
		
		self.toolbar=None
		self.cb=None
		self.editor=None
		
		if mode==0:wxPanel.__init__(self,parent,self.ID,wxDefaultPosition,name="EditorContainer")
		else:
			dialogsize=wxSize(w,h+100)
			self.x=wxDialog(parent,wxNewId(),'EduAppEditor',size=dialogsize)#optional to use this
			wxPanel.__init__(self,self.x,self.ID,wxDefaultPosition,name="EditorContainer")


	def setup(self):		
		if self.mode==1:return
		if DEBUG:print 'EduAppEditor::setup'
		
		self.toolbar=wxToolBar(self,wxNewId(),style=wxTB_HORIZONTAL | wxNO_BORDER | wxTB_FLAT | wxTB_TEXT)

		button_size=wxSize(100,25)

		#...........................................................
		#COMBO BOX
		cbID=wxNewId()
		self.cb=wxComboBox(self.toolbar,cbID,size=wxSize(200,50),choices=self.get_installed())
		self.toolbar.AddControl(self.cb)
		EVT_COMBOBOX(self.toolbar,cbID,self.edit_target)
		
		#...........................................................
		#SAVE BUTTON
		xid=wxNewId()
		saveB=wxButton(self.toolbar,xid,"Save",size=button_size)
		self.toolbar.AddControl(saveB)
		EVT_BUTTON(self.toolbar,xid,self.saveCB0)

		#...........................................................
		#DELETE BUTTON
		xid=wxNewId()
		deleteB=wxButton(self.toolbar,xid,"Delete",size=button_size)
		self.toolbar.AddControl(deleteB)
		EVT_BUTTON(self.toolbar,xid,self.deleteCB0)

		#...........................................................
		#LOGOUT BUTTON
		xid=wxNewId()
		logoutB=wxButton(self.toolbar,xid,"Logout",size=button_size)
		self.toolbar.AddControl(logoutB)
		EVT_BUTTON(self.toolbar,xid,self.logoutCB0)

		self.editor=wxTextCtrl(self,wxNewId(),style=wxTE_MULTILINE|wxTE_PROCESS_ENTER|wxTE_PROCESS_TAB)
		if self.font:self.editor.SetFont(font)
		
		"""
		if self.target:
			inf=open(target)
			content=eval(inf.read(),{"__builtins__": {}})
			cfg=format_dict(content,0)
			self.editor.WriteText(cfg)
		"""
		self.reload('new')	
	
	def get_installed(self):
		fnames=os.listdir(os.path.join(self.env.configdir,self.tab_name))
		rnames=[]
		for f in fnames:
			if string.find(f,'.')<0:
				rnames.append(f)
		return rnames

	def load_config(self,intermediate_path,fname):
		
		sitepkgdir	=self.env.sitepkgdir
		configdir	=self.env.configdir
		userdir		=self.env.userdir
		if DEBUG:print configdir,intermediate_path,fname
		infname=os.path.join(configdir,intermediate_path,fname)
		inf=open(infname)
		content=inf.read()
		
		#NEED:re-format tripple-quoted multiline strings
		content=string.strip(content)
		if DEBUG:print content
		
		config=eval(content)
		inf.close()
		return config

	def reload(self,name):
		self.cb.Clear()
		installed=self.get_installed()
		for idx in range(len(installed)):
			self.cb.Append(installed[idx])
		self.cb.SetValue(name)
		self.edit_target(None)

	def edit_target(self,e):
		if DEBUG:print 'eduapp_editor::edit_target',self.cb.GetValue()
		ip=self.editor.GetInsertionPoint()
		self.editor.Clear()
		target=self.cb.GetValue()
		
		sitepkgdir=self.env.sitepkgdir
		configdir=self.env.configdir
		userdir=self.env.userdir
		
		if not target:target='new'
		
		cfg=None
		if target !='new':
			if self.tab_name=='accounts':
				if DEBUG:print target
				cfg=format_dict(self.load_config(os.path.join('accounts',target),'config'),0)
				if DEBUG:print cfg
			elif self.tab_name=='assignment':
				cfg=format_dict(self.load_config(self.tab_name,target),0)
			else:
				cfg=format_dict(self.load_config(self.tab_name,target),0)
			
		elif self.tab_name=='accounts':
			#cfg=format_dict(self.parent.global_config,0)
			cfg={
				'IDNgrade':		0,
				'IDNstudent':	0,
				'IDNsession':	0,
				'IDNteacher':	0,
				'assignments':	[],
				'username':		'new',
				'password':		'',
				'high_score':	0,
			}
		elif self.tab_name=='assignments':
			#cfg=format_dict(self.parent.global_config,0)
			cfg={
				'name':'new',
				'type':'0',
				'articles':[],
			}
				
		if cfg:
			#Next lines are because sometimes cfgs loaded as strings, but 'new' cfgs (i.e. hardcoded above) are 
			#more easily formatted as code objects so can use single tics
			try:
				cfg=eval(cfg)
			except Exception,e:
				if DEBUG:print 'eduapp_editor::edit_target -- could not eval(cfg)',type(cfg),e
			
			try:
				cfg=format_dict(cfg,0)
				self.editor.WriteText(cfg)
				self.editor.SetInsertionPoint(ip)
				
			except Exception,e:
				if DEBUG:print 'eduapp_editor::edit_target -- error formatting or writing',e
		
	def ShowModal(self):
		
		self.editor=wxTextCtrl(self,wxNewId(),style=wxTE_MULTILINE|wxTE_PROCESS_ENTER|wxTE_PROCESS_TAB)
		if self.font:self.editor.SetFont(font)
		
		id_createB=wxNewId()
		createB=wxButton(self,id_createB,"Create")
		EVT_BUTTON(createB,id_createB, self.createCB)
		
		id_cancelB=wxNewId()
		cancelB=wxButton(self,id_cancelB,"Cancel")
		EVT_BUTTON(cancelB,id_cancelB, self.cancelCB)
		
		vbox=wxBoxSizer(wxVERTICAL)
		vbox.Add(self.editor,1,wxEXPAND,1)
		
		hbox=wxBoxSizer(wxHORIZONTAL)
		hbox.Add(createB,0,1,1)
		hbox.Add(cancelB,0,1,1)
		vbox.Add(hbox,0,1,1)
		
		self.SetSizer(vbox)
		self.SetAutoLayout(True)

		self.x.Centre()
		rval=self.x.ShowModal()
		if rval==1:#Create
			return self.editor.GetValue()
		else:
			return None
		
	def createCB(self,e):
		if DEBUG:print 'createCB'
		self.x.EndModal(1)
	
	def saveCB(self,e):
		if DEBUG:print 'saveCB'
		self.x.EndModal(1)
		
	def cancelCB(self,e):
		if DEBUG:print 'cancelCB'
		self.x.EndModal(2)

	def save(self):
		ouf=open(self.target,'w')
		ouf.write(self.editor.GetValue())
		ouf.close()
		
	def saveCB0(self,e):
		
		d=None
		content=self.editor.GetValue()
		content=string.strip(content)
		if DEBUG:print content
		#text key/val is often multi-line in an assignment...need to extract newlines from this field for save/reload
		if 0:#self.tab_name=='assignment':
			
			qtype=None
			scontent=string.split(content,"'text':",1)
			scontent[1]=string.strip(scontent[1])#remove any leading carriage returns
			
			#get the bounding quote type:
			if scontent[1][0:3]=='"""':qtype=2
			elif scontent[1][0]=='"':qtype=1
			elif scontent[1][0]=="'":qtype=0
			else:qtype=None
			
			#get the value of the text field:
			text_value=None
			remainder=None
			if qtype==0:
				text_value=string.split(scontent[1][1:],"'",1)[0]
				remainder=string.split(scontent[1][1:],"'",1)[1]
			elif qtype==1:
				text_value=string.split(scontent[1][1:],'"',1)[0]
				remainder=string.split(scontent[1][1:],'"',1)[1]
			elif qtype==2:
				text_value=string.split(scontent[1][3:],'"""',1)[0]
				remainder=string.split(scontent[1][1:],'"""',1)[1]
			
			text_value=string.replace(text_value,'\n','')
			
			#re-assemble the pieces:
			content=scontent[0]+"'text':"+'"""'+text_value+'"""'+remainder
			
			
		try:
			d=eval(content)
			if self.tab_name=='accounts':
				if d['username']=='new':return
				else:oufdir=os.path.join(self.env.configdir,self.tab_name,d['username'])
				
				if not os.path.exists(oufdir):os.mkdir(oufdir)
				oufname=os.path.join(oufdir,'config')
				ouf=open(oufname,'w')
				ouf.write(string.replace(self.editor.GetValue(),'\\','\\\\'))
				ouf.close()
				self.reload(d['username'])
			
			elif self.tab_name=='assignments':
				if d['name']=='new':return
				else:oufname=os.path.join(self.env.configdir,self.tab_name,d['name'])
				
				ouf=open(oufname,'w')
				ouf.write(content)#NOTE:here we write the multiline-repaired content (rather than ed.value)
				ouf.close()
				self.reload(d['name'])

				
			
		except Exception,e:
			if DEBUG:print e
			self.reload('new')
			
		
	def logoutCB0(self,e):
		self.dialog.EndModal(0)
		
	def deleteCB0(self,e):
	
		d=eval(self.editor.GetValue(), {"__builtins__": {}})
		if d['username']=='new':return
		if d['username']=='admin':return
		if d['username']=='guest':return
		
		fname=os.path.join(self.env.userdir,d['username'])
		try:os.removedirs(fname)
		except:pass#print 'unable to recursively delete 1x',fname
		
		cmd=None
		if self.env.OS=='lin':cmd="rm -rf %s"%(fname)
		else:cmd="del %s"%(fname)
		print cmd
		try:os.system(cmd)
		except:pass#print 'unable to recursively delete 2x',fname
		
		self.reload("")
	
