"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""
import os,sys,string,time
from wxPython.wx import *
from login import *
from admin import *
from environment import *


class EduCore(wxFrame):
	
	def __init__(self,ID,appdir):
		
		
		wxFrame.__init__(self, None, ID, '', size=(1,1))
		wxInitAllImageHandlers()
		self.Centre(wxBOTH)
		
		
		self.env=Environment(appdir)
		self.sitepkgdir=self.env.sitepkgdir
		self.configdir=self.env.configdir
		self.userdir=self.env.userdir
		
		self.global_config=self.load_config(os.path.join('accounts','globals'),'config')
		
		self.admin=AdminDialog(self)
		self.Show(False)
		
	def goadmin(self):
		rval=self.admin.ShowModal()
		
	
	def load_config(self,intermediate_path,fname):
		
		sitepkgdir	=self.env.sitepkgdir
		configdir	=self.env.configdir
		userdir		=self.env.userdir
		if DEBUG:print configdir,intermediate_path,fname
		infname=os.path.join(configdir,intermediate_path,fname)
		inf=open(infname)
		content=inf.read()
		
		#NEED:re-format tripple-quoted multiline strings
		content=string.strip(content)
		if DEBUG:print content
		
		config=eval(content)
		inf.close()
		return config
	
	"""
	def load_config(self,account):
		
		sitepkgdir	=self.env.sitepkgdir
		configdir	=self.env.configdir
		userdir		=self.env.userdir
		
		infname=os.path.join(userdir,account,'config')
		inf=open(infname)
		config=eval(inf.read())
		inf.close()
		return config
	"""
		
	def refresh_highscores(self):
		
		sitepkgdir	=self.env.sitepkgdir
		configdir	=self.env.configdir
		userdir		=self.env.userdir
		
		highscores=[]
		
		for account in os.listdir(userdir):
			
			if not os.path.isdir(os.path.join(userdir,account)):continue
			if account=='admin' :continue
			if account=='new':continue
			if account=='globals':continue
			
			config=self.load_config(os.path.join('accounts',account),'config')
			
			insert_flag=0
			for idx in range(len(highscores)):
				if len(highscores)==0:
					highscores.insert(idx,(config['username'],config['high_score']))
					insert_flag=1
					break
				elif config['high_score']>highscores[idx][1]:
					highscores.insert(idx,(config['username'],config['high_score']))
					insert_flag=1
					break
				if insert_flag:break
					
			if not insert_flag:
				highscores.append((config['username'],config['high_score']))
				
		return highscores
