"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""
import os,sys
from wxPython.wx import *
import wx.lib.editor as editor
#from environment import *

DEBUG=False

class LoginDialog:
	
	def __init__(self,parent,titlebar):
		self.cfg=None
		self.parent=parent
		
		if parent.env.OS=='win':
			self.size=wxSize(400,320)
		else:
			self.size=wxSize(400,300)
		
		self.x=wxDialog(self.parent,wxNewId(),titlebar,size=self.size)
		self.x.Centre()
		
		bmp=wxBitmap(parent.global_config['splash_top'])
		wxStaticBitmap(self.x,wxNewId(),bmp,(0,0))
		
		bmp=wxBitmap(parent.global_config['splash_bot'])
		wxStaticBitmap(self.x,wxNewId(),bmp,(0,250))
		
	def login(self):
	
		x=self.x
		size=self.size
		xc=size[0]/2
		yc=size[1]/2
		
		wtot=150
		wlabel=int(.5*wtot)
		wlogin=int(.5*wtot)
		hlabel=20
		hlogin=20
		
		xlabel=xc-wlabel
		ylabel=yc-hlabel
		xlogin=xc
		ylogin=ylabel
		
		wloginb=60
		hloginb=30
		xloginb=xc-2*wloginb
		yloginb=ylogin+3*hlogin
		
		wexit=wloginb
		hexit=hloginb
		xexit=xc-wloginb
		yexit=yloginb

		wcancel=wloginb
		hcancel=hloginb
		xcancel=xc
		ycancel=yloginb
		
		wguest=wloginb
		hguest=hloginb
		xguest=xc+wloginb
		yguest=yloginb
		
		whslabel=100
		#hslabel=wxStaticText(x,wxNewId(),"highscore:",pos=wxPoint(xlabel,ylabel-hlabel),size=wxSize(whslabel,hlabel))
		#hslabel=wxStaticText(x,wxNewId(),"%s: %d"%(self.hs[0],self.hs[1]),pos=wxPoint(xlogin,ylabel-hlabel),size=wxSize(300,hlabel))
		
		ulabel=wxStaticText(x,wxNewId(),"username",pos=wxPoint(xlabel,ylabel),size=wxSize(wlabel,hlabel))
		plabel=wxStaticText(x,wxNewId(),"password",pos=wxPoint(xlabel,ylabel+hlabel),size=wxSize(wlabel,hlabel))
		self.ufield=wxTextCtrl(x,wxNewId(),"",pos=wxPoint(xlogin,ylogin),size=wxSize(wlogin,hlogin),style=0)
		passID=wxNewId()
		self.pfield=wxTextCtrl(x,passID,"",pos=wxPoint(xlogin,ylogin+hlogin),size=wxSize(wlogin,hlogin),style=wxTE_PASSWORD|wxTE_PROCESS_ENTER)
		EVT_TEXT_ENTER(self.pfield,passID,self.validate)

		xid=wxNewId()
		loginButton=wxButton(x,xid,"Login",pos=wxPoint(xloginb,yloginb),size=wxSize(wloginb,hloginb))
		EVT_BUTTON(loginButton, xid, self.validate)

		xid=wxNewId()
		exitButton=wxButton(x,xid,"Quit",pos=wxPoint(xexit,yexit),size=wxSize(wexit,hexit))
		EVT_BUTTON(exitButton, xid, self.quitCB)

		xid=wxNewId()
		cancelButton=wxButton(x,xid,"Cancel",pos=wxPoint(xcancel,ycancel),size=wxSize(wcancel,hcancel))
		EVT_BUTTON(cancelButton, xid, self.cancelCB)
		
		xid=wxNewId()
		guestButton=wxButton(x,xid,"Guest",pos=wxPoint(xguest,yguest),size=wxSize(wguest,hguest))
		EVT_BUTTON(guestButton, xid, self.guestCB)
		
		x.Centre()
		self.ufield.SetFocus()
		self.ufield.SetFocus()
		self.ufield.SetFocus()
		
		rval=x.ShowModal()
		
		if self.cfg==None:
			return None
		else:
			return self.cfg
		
			
	def quitCB(self,e):
		self.x.Destroy()
		sys.exit()
	
	def cancelCB(self,e):
		self.x.EndModal(2)
			
	def validate(self,e):
		self.cfg=None
		sitepkgdir=self.parent.env.sitepkgdir
		configdir=self.parent.env.configdir
		userdir=self.parent.env.userdir
		
		valid=0
		name_submission=self.ufield.GetValue()
		password_submission=self.pfield.GetValue()
		
		try:
			if not os.path.exists(userdir):
				self.x.EndModal(0)
				return None
			if not os.listdir(userdir).count(name_submission):
				self.x.EndModal(0)
				return None
		except:
			self.x.EndModal(0)
			return None
		
		infname=os.path.join(userdir,name_submission,'config')
		if DEBUG:print userdir,name_submission,'config'
		
		cfg=self.load_config(infname)
		valid=1
		self.cfg=cfg
		
		if cfg.has_key('password') and cfg['password']==password_submission:
			valid=1
			self.cfg=cfg
		else:
			valid=0
			self.cfg=None
		
		self.x.EndModal(valid)
	
	def guestCB(self,e):
		self.cfg=None
		sitepkgdir=self.parent.env.sitepkgdir
		configdir=self.parent.env.configdir
		userdir=self.parent.env.userdir
		
		valid=0
		password_submission=self.pfield.GetValue()
		
		infname=os.path.join(userdir,'guest','config')
		cfg=self.load_config(infname)
		if cfg.has_key('password') and cfg['password']==password_submission:
			valid=1
			self.cfg=cfg
		else:
			valid=0
			self.cfg=None
		
		self.x.EndModal(valid)
			
	def load_config(self,infname):
		sitepkgdir=self.parent.env.sitepkgdir
		configdir=self.parent.env.configdir
		userdir=self.parent.env.userdir

		inf=open(infname)
		cfg=eval(inf.read())
		inf.close()
		return cfg
		


