"""
/***************************************************************************

	Author			:Charles B. Cosse 
	
	Email			:ccosse@gmail.com
					
	Website			:www.asymptopia.org
	
	Copyright		:(C) 2002-2007 Asymptopia Software.
	
 ***************************************************************************/
"""

import os,sys,string,time,thread
from wxPython.wx import *
from educore import *
from eduapp  import *
from tms_window import *
from projectile import *
from tms_admin import *

class TuxMathScrabble(wxApp):
	
	def __init__(self,appdir):
		wxApp.__init__(self, 0)
		prog=TMS_App(appdir)
		prog.run()

	def OnButton(self, evt):
		self.prog.Close(true)
		

class TMS_App(EduCore):

	def __init__(self,appdir):
	
		EduCore.__init__(self,wxNewId(),appdir)
		self.admin=TMS_AdminDialog(self)

	
	def run(self):
		
		while True:
			
			MODE=0
			pygame.init()
			
			self.global_config=self.load_config(os.path.join('accounts','globals'),'config')
			
			game_panel=TMS_Window(self,'guest',MODE)
			
			high_score_list=self.refresh_highscores()
			
			while True:
				rval=game_panel.setup_common()
				rval=game_panel.fw_show()
				if rval[1]!=-2:break;
				
				try:
					guest_level=self.global_config['guest_level']
					possible_levels=[1,2,3,4]
					if possible_levels.count(guest_level):pass
					else:guest_level=(1+int(random()*4))
					
				except:
					guest_level=(1+int(random()*4))
				
				rval=game_panel.run(guest_level,high_score_list)
				if rval[1]!=-2:break;#-2 returned for autopilot restart
			
			
			unused_screen_reference=pygame.display.set_mode((1,1))#reduce btw demo & login
			self.global_config=self.load_config(os.path.join('accounts','globals'),'config')
			
			username=None
			login=LoginDialog(self,self.global_config['title_string'])
			user_config=login.login()
			if not user_config:continue
			
			if user_config['username']=='admin':
				rval=self.admin.ShowModal()
				
			else:
				MODE=1
				game_panel=TMS_Window(self,user_config['username'],MODE)
				rval=game_panel.setup_common()
				rval=(0,self.global_config['DEFAULT_LEVEL'])
				while(True):
					rval=game_panel.run(rval[1],[])
					if rval[1]==-1:break;
					
			
